//------------------------------------------------
//
//                Code
//
//
//           2006.06.13
//
//------------------------------------------------

#include "CGgui.h"
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <ctime>

#include "TCanvas.h"
#include "TBrowser.h"
#include "TString.h"
#include "TFile.h"
#include "TStopwatch.h"

#include "TF1.h"
#include "TRandom.h"
#include <TRootEmbeddedCanvas.h>


using namespace std;

ClassImp(CGgui)

CGgui::CGgui() : TQObject()
{
    fMain = new TGMainFrame(gClient->GetRoot(),0,0);
    //data
    fValue  = 0;
    samples = 0;
    
    //histos
    H1time  = new TH1D("T1 evol",";t[s];T1[k]" ,10,0,10);
  
    SetHistos();
    //layouts---------------------------
    lexpXY  = new TGLayoutHints(kLHintsExpandX | kLHintsExpandY,10,10,10,1);
    lexpXY2 = new TGLayoutHints(kLHintsExpandX|kLHintsExpandY,5,5,5,5);
    cx1     = new TGLayoutHints(kLHintsCenterX,5,5,3,4);
    fLMM    = new TGLayoutHints(kLHintsRight|kLHintsTop|kLHintsExpandX|kLHintsExpandY,5,5,5,5);
    fLck    = new TGLayoutHints(kLHintsRight|kLHintsTop|kLHintsExpandX,5,5,5,5);

    //Canvas------------
    hCanvasframe = new TGHorizontalFrame(fMain,500,500); //w h
    C1canva  = new TRootEmbeddedCanvas("C1canva",hCanvasframe,300,300);
    hCanvasframe->AddFrame(C1canva,fLMM);
    fMain->AddFrame(hCanvasframe,lexpXY2);

    //groups frame-----------------------------
    hGroupsframe = new TGHorizontalFrame(fMain,300,100); //w h
    RunGF = new TGGroupFrame(hGroupsframe,"Running modes",kVerticalFrame);
   
    //run group -------------------------------
    Vgrunf1   = new TGVerticalFrame(RunGF,200,40);
    hgrunf2   = new TGHorizontalFrame(RunGF,200,40);
    hgrunf3   = new TGHorizontalFrame(RunGF,200,40);
    SetRunGroup();   //buttons and functions
    RunGF->AddFrame(Vgrunf1,fLck); //add the frames
    RunGF->AddFrame(hgrunf2,fLck);
    RunGF->AddFrame(hgrunf3,fLck);
    hGroupsframe->AddFrame(RunGF,fLMM);
    fMain->AddFrame(hGroupsframe,lexpXY2);

    exit = new TGTextButton(fMain,"E&xit","gApplication->Terminate(0)");
    fMain->AddFrame(exit,cx1);

    fMain->SetWindowName("Slow Control Monitoring Example");
    fMain->MapSubwindows();
    fMain->Resize(fMain->GetDefaultSize());
    fMain->MapWindow();

}//-----------------------------------

//destructor---------------
CGgui::~CGgui(){
     fMain->Cleanup();
     delete fMain;
}//----------------------

//histo setting----------------------
void CGgui::SetHistos(){

    H1time->SetTitle("");
    H1time->SetMarkerSize(0.1);
    H1time->GetYaxis()->SetRangeUser(250,310);
    H1time->SetBit(TH1::kCanRebin);
  
}//----------------------------------

//--------run group setting--------
void CGgui::SetRunGroup(){

    SS = new TGCheckButton(Vgrunf1,"Star/ Stop NI DAC",10);    //Vframe1
    RR = new TGCheckButton(Vgrunf1,"Show  NI acq data",20);
    SS->SetState(kButtonUp);
    RR->SetState(kButtonUp);
    SS->Connect("Clicked()","CGgui",this,"StartStop()");      //hframe
    RR->Connect("Clicked()","CGgui",this,"PrintNIdata()");    
    Lent  = new TGLabel(hgrunf2, new TGString("entries :"));
    Ltim  = new TGLabel(hgrunf3, new TGString("Run time:"));
    Nent  = new TGNumberEntryField(hgrunf2, 999, 0,
                                   TGNumberFormat::kNESRealThree, 
                                   TGNumberFormat::kNEAAnyNumber); 
    Ntim  = new TGNumberEntryField(hgrunf3, 998, 0,
                                   TGNumberFormat::kNESRealThree, 
                                   TGNumberFormat::kNEAAnyNumber); 
    Showe = new TGTextButton(hgrunf2,"Show &E",50);
    Showt = new TGTextButton(hgrunf3,"Show &T",51);
    Showe->Connect("Clicked()","CGgui",this,"ShowEntries()");
    Showt->Connect("Clicked()","CGgui",this,"ShowRunTime()");

    Vgrunf1->AddFrame(SS,fLck);   //add buttons 2 Vframe1
    Vgrunf1->AddFrame(RR,fLck);
   
    hgrunf2->AddFrame(Showe,fLck); //add buttons 2 hframe2
    hgrunf2->AddFrame(Nent,fLck);
    hgrunf2->AddFrame(Lent,fLck);

    hgrunf3->AddFrame(Showt,fLck); //add buttons 2 hframe3
    hgrunf3->AddFrame(Ntim,fLck);
    hgrunf3->AddFrame(Ltim,fLck);

}//-------------------------------

//------------Start Stop button funct--------------
void CGgui::StartStop()
{
    TGButton *btn = (TGButton *) gTQSender;
    int id =  btn->WidgetId();
    printf(" pressed button ID = %d\n", id);

    EButtonState ssbs  = SS->GetState();
    EButtonState rrbs  = RR->GetState();
    // kButtonUp =0 , kButtonDown=1
    
    gRandom->SetSeed();
    c1 = C1canva->GetCanvas();
 
    int i = 0 ;                 //events

    if (ssbs==1){
	cout << " Started     : " << ssbs << endl ;
	start = time(NULL);
	while (i>=0) {
	    sleep(1);                  //sleep 1 sec
	    gSystem->ProcessEvents();  //handle GUI events
	    SetData(i);                //read 1 time 
	    Refresh(i);                //refresh if i%10
	    ssbs = btn->GetState();
	    if (ssbs==0) break;
	    i++;
	}
	//cout << " time After :" << CalculateTimeStamp() << endl;
    }
    else if (ssbs==0){
	cout << " Stopped     : " << ssbs << endl ;
	if (rrbs==0){
	    cout << " Silent mode : " << rrbs << endl;
	}
	else if (rrbs==1){
	    cout << " NI data will be printed : " << rrbs << endl;	
	}
	end = time(NULL);
	dift = difftime(end,start);
	printf(" Total running time %.2lf seconds.\n",dift);
	cout <<" Samples = " <<  GetSamples() << endl;
	gSystem->ProcessEvents();  // handle GUI events
    }
   

}//-------button handler------------

//set the values that we will use-----
void CGgui::SetData(int i){

    samples++;
    EButtonState rrst = RR->GetState();
    xs1  = (gRandom->Gaus(0,1))+273.16; 
    end  = time(NULL);
    dift = difftime(end,start); 
    H1time->SetBinContent(dift,xs1);
   
    if (rrst==1) cout << xs1 << end;
    
}//---------------------------

//redraw the canvas-----------------------
void CGgui::Refresh(int i){

    const Int_t kUPDATE = 10; //refreshing rate
    if (!(i % kUPDATE)) {

	if (i == kUPDATE) {
	    c1->cd();
	    H1time->SetMarkerColor(kRed);
	    H1time->Draw("P*"); 
	}
	c1->Modified();
	c1->Update();
    }

}//-----------------------------

void CGgui::PrintNIdata(){

    EButtonState rrst = RR->GetState();
    if (rrst==1)      cout << " Printing NI raw data " << endl;
    else if (rrst==0) cout << " No printing mode" <<endl;

}//---choose the origin of the data-------

void CGgui::ShowEntries(){

    int sam = GetSamples();
    Nent->SetNumber(sam);
    cout << "Samples : " <<  sam << endl;
   
}//---------------------------
void CGgui::ShowRunTime(){

    EButtonState ssbs = SS->GetState();
    if  (ssbs==1) {
	end = time(NULL);
	dift = difftime(end,start);
	Ntim->SetNumber(dift);
	cout << "Current time : "  << dift << endl;
    }
    else {
	Ntim->SetNumber(dift);
	cout << "Total time : "  << dift << endl;
    }

}//-------------------------------

void CGgui::SetValue(Int_t Value){

    if (Value != fValue){
        fValue = Value;
        Emit("SetValue(Int_t)",fValue);
    }

}//---------------------------

