//----------------------------
//
//          CGgui.h
//
//----------------------------

#include <cstdlib>
#include <fstream>
#include <ctime>

#include <TROOT.h>
#include <TApplication.h>

#include <TGClient.h>
#include <TGButton.h>

#include <TGLabel.h>
#include <TGTextEntry.h>
#include <TGNumberEntry.h>

#include <TGTextBuffer.h>

#include <TCanvas.h>
#include <TH1.h>
#include <TH2D.h>

#include <TQObject.h>
#include <RQ_OBJECT.h>
#include <TSystem.h>

class TGMainFrame;
class TRootEmbeddedCanvas;
class TGLayoutHints;
class TGHorizontalFrame;
class TGVerticalFrame;
class TGGroupFrame;
class TGCheckButton;
class TGButton;
class TGTextEntry;
class TGTextBuffer;

class CGgui : public TQObject {
    RQ_OBJECT("CGgui")

private:
    Int_t fValue;
    //frames--------------------------
    TGMainFrame          *fMain;
    TGHorizontalFrame    *hCanvasframe;  //canvas
    TRootEmbeddedCanvas  *C1canva;
    TGHorizontalFrame    *hGroupsframe;  //groups
    TGGroupFrame         *RunGF;
    TGVerticalFrame      *Vgrunf1;
    TGHorizontalFrame    *hgrunf2, *hgrunf3;
    TGHorizontalFrame    *hgsetf1, *hgsetf2, *hgsetf3, *hgsetf4;
    TGHorizontalFrame    *hgoptf1, *hgoptf2, *hgoptf3, *hgoptf4;
    //run group----------------------
    TGCheckButton        *SS, *RR;
    TGLabel            *Lent, *Ltim;
    TGNumberEntryField *Nent, *Ntim;
    TGTextEntry        *Tent;
    TGTextBuffer       *Bent;
    TGTextButton      *Showe, *Showt; 
    //external----------------------------
    TGTextButton         *exit;
    //layauts----------------------
    TGLayoutHints *lexpXY, *lexpXY2, *cx1, *fLMM, *fLck;
    //data--------------
    Int_t samples;
    Float_t     xs1;
    TCanvas     *c1;
    TH1D    *H1time;
    time_t start;  
    time_t   end;  
    double dift;
    
public:
    CGgui();
    virtual ~CGgui();
    virtual void Clicked() { Emit("Clicked()");}

    void SetValue(Int_t Value);       //signal
    void PrintValue() const { printf("value = %d\n",fValue);}
    //formatting
    void SetHistos();
    void SetRunGroup();
   
    //button functions----------
    void StartStop();
    void PrintNIdata();
    void ShowEntries();
    void ShowRunTime();

    //data functions-------------
    void SetData(int i);
    void Refresh(int i);
    Int_t GetSamples() { return samples;}

    ClassDef(CGgui,0)

};
